<template>
	<v-card class="pa-4" width="30vw" height="55vh" id="chart">
		<h1 class="text-center mb-6 lineTitle">אירועים חריגים</h1>
		<line-chart ref="lineChart" :chartData="chartData" :options="options" />
	</v-card>
</template>

<script>
import LineChart from './LineChart';
import datesNames from 'date-names';
import dateFormat from 'date-format';
import api from '../api';

export default {
	name: 'EventChart',
	components: { LineChart },
	data() {
		return {
			chartData: {
				labels: [],
				datasets: [
					{
						label: 'ערך הסף',
						data: [],
						fill: false,
						borderColor: '#f6a9fc',
						tension: 0.2,
					},
					{
						label: 'מספר אירועים',
						data: [],
						fill: false,
						borderColor: '#5e8b7e',
						tension: 0.2,
					},
				],
			},
			options: {
				maintainAspectRatio: false,
			},
		};
	},
	created() {
		this.loadChart();
	},
	methods: {
		async getThreshold() {
			return await api.reports.allThresholds().then(res => {
				return res.data;
			});
		},
		async getPreviousWeekReports() {
			return await api.reports.previousWeekReports().then(res => {
				return res.data;
			});
		},
		loadChart() {
			this.chartData.datasets[0].data.length = 0;
			this.chartData.datasets[1].data.length = 0;
			this.chartData.labels.length = 0;

			Promise.all([this.getThreshold(), this.getPreviousWeekReports()]).then(
				values => {
					const thresholdArray = values[0];
					const eventsArray = values[1].reverse();

					eventsArray.forEach(eventsDate => {
						const date = new Date(eventsDate.date);
						const day = date.getDay();
						const dayLabel = datesNames.abbreviated_days[day];
						const dateLabel = dateFormat.asString('dd/MM/yy', date);
						this.chartData.labels.push([dayLabel, dateLabel]);
						this.chartData.datasets[0].data.push(thresholdArray[day].threshold);
						this.chartData.datasets[1].data.push(eventsDate.count);
					});

					this.$refs.lineChart.loadChart();
				},
			);
		},
	},
};
</script>

<style>
#chart {
	background-color: #dfeeea;
	opacity: 0.95;
}

.lineTitle {
	color: #38919b;
}
</style>
